/**
* ...
* @author Dani Llops
* @version 0.1
*/

package{
	import flash.display.*;
	import flash.events.MouseEvent;
	import flash.geom.*;
	
	public class MainPaint extends Sprite
	{	
		// Bitmap para la paleta de colores
		private var _bmpDataColores:BitmapData = new BitmapData(100, 120, false, 0);
		private var _bmpColores:Bitmap = new Bitmap(_bmpDataColores);
		
		// Bitmap para poder pintar
		private var _bmpDataCanvas:BitmapData = new BitmapData(150, 120, false, 0);
		private var _bmpCanvas:Bitmap = new Bitmap(_bmpDataCanvas);
		
		// Contenedores de los bitmaps
		private var _paleta:Sprite = new Sprite();
		private var _canvas:Sprite = new Sprite();
		
		// Variable para almacenar el color elegido
		private var _color_temp:uint;
		
		function MainPaint() 
		{	
			// Ajustamos el bitmap de los colores
			_bmpColores.x = 15;
			_bmpColores.y = 15;
			_paleta.addChild(_bmpColores);
			
			// Ajustamos el bitmap del canvas
			_bmpCanvas.x = 130;
			_bmpCanvas.y = 15;
			_canvas.addChild(_bmpCanvas);
			
			// Aadimos los contenedores
			addChild(_paleta);
			addChild(_canvas);
			
			// Creamos los colores de la paleta mediante el mtodo fillRect,
			// que rellena un rectangulo de un color, igual que el cubo de pintura
			_bmpDataColores.fillRect(new Rectangle(0, 0, 50, 30), 0xFF6699);
			_bmpDataColores.fillRect(new Rectangle(50, 0, 50, 30), 0x6666CC);
			_bmpDataColores.fillRect(new Rectangle(0, 30, 50, 30), 0xFF9999);
			_bmpDataColores.fillRect(new Rectangle(50, 30, 50, 30), 0x6699CC);
			_bmpDataColores.fillRect(new Rectangle(0, 60, 50, 30), 0xFFCC99);
			_bmpDataColores.fillRect(new Rectangle(50, 60, 50, 30), 0x66CCCC);
			_bmpDataColores.fillRect(new Rectangle(0, 90, 50, 30), 0xFFFF99);
			_bmpDataColores.fillRect(new Rectangle(50, 90, 50, 30), 0x66FFCC);
			
			// Eventos
			_paleta.addEventListener(MouseEvent.CLICK, cogerColor);
			_canvas.addEventListener(MouseEvent.CLICK, pintarColor);
		}
		
		private function cogerColor(e:MouseEvent):void 
		{
			// Cogemos la posicion del raton sobre el bitmap de colores
			var cx:int = _bmpColores.mouseX;
			var cy:int = _bmpColores.mouseY;
			
			// Obtenemos el color y lo almacenamos
			_color_temp = _bmpDataColores.getPixel(cx, cy);
		}
		
		private function pintarColor(e:MouseEvent):void 
		{
			// Cogemos la posicion del raton sobre el bitmap del canvas
			var cx:int = _bmpCanvas.mouseX;
			var cy:int = _bmpCanvas.mouseY;
			
			// Pintamos el pixel del color almacenado
			_bmpDataCanvas.setPixel(cx, cy, _color_temp);
		}
	}
}